/*
 * Door.cpp
 *
 *  Created on: 8. mars 2011
 *      Author: John Sverre Solem
 */

#include <iostream>
#include "Door.h"
#include <boost/asio.hpp>
#include <boost/date_time/posix_time/posix_time.hpp>

using namespace std;

Door::Door()
{
	this->rc = new RelayController();
	cout << "Door created" << endl;
	this->door_status = DOOR_CLOSED;
}

Door::~Door()
{
	delete rc;
}

void Door::openDoor(){
	if(isOpen()) return;
	this->door_status = DOOR_OPEN;
	cout<<"opening door..."<<endl;

	boost::asio::io_service io;

	rc->turnOnRelay(2);

	boost::asio::deadline_timer t(io, boost::posix_time::milliseconds(1400)); //1600
	t.wait();

	rc->turnOffRelay(2);

	cout<<"door opened."<<endl;
}

void Door::closeDoor(){
	if(isClosed()) return;
	this->door_status = DOOR_CLOSED;
	cout<<"closing door..."<<endl;

	boost::asio::io_service io;

	rc->turnOnRelay(1);

	boost::asio::deadline_timer t(io, boost::posix_time::milliseconds(1350)); //1250
	t.wait();
	rc->turnOffRelay(1);

	cout<<"door closed."<<endl;
}

void Door::stopDoor(){
	if(isStopped()) return;
	this->door_status = DOOR_STOPPED;
	rc->turnOffAllRelays();
	cout << "stopped door!"<<endl;
}

bool Door::isOpen() const{
	if(this->door_status == DOOR_OPEN) return true;
	return false;
}

bool Door::isClosed() const{
	if(this->door_status == DOOR_CLOSED) return true;
	return false;
}

bool Door::isStopped() const{
	if(this->door_status == DOOR_STOPPED) return true;
	return false;
}
