/*
 * RelayController.cpp
 *
 *  Created on: 9. mars 2011
 *      Author: sliding
 */

#include "RelayController.h"
#include "SerialPort.h"

RelayController::RelayController()
{
	// open first serial port
	this->serialport = new SerialPort("/dev/ttyS0");
}

RelayController::RelayController(string portname){
	// initialize serial port communication
	this->serialport = new SerialPort(portname);
}

RelayController::~RelayController()
{
	delete this->serialport;
}

void RelayController::turnOnRelay(int relaynumber){
	int no;
	if(relaynumber == 1) no = 1;
	else if(relaynumber == 2) no = 3;
	else return;

	const char mode = static_cast<char>(254);
	const char message = static_cast<char>(no);

	// send message to relay controller
	this->serialport->port_write(&mode);
	this->serialport->port_write(&message);
}

void RelayController::turnOffRelay(int relaynumber){
	int no;
	if(relaynumber == 1) no = 0;
	else if(relaynumber == 2) no = 2;
	else return;

	const char mode = static_cast<char>(254);
	const char message = static_cast<char>(no);

	// send message to relay controller
	this->serialport->port_write(&mode);
	this->serialport->port_write(&message);
}

void RelayController::turnOnAllRelays(){

	const char mode = static_cast<char>(254);
	const char message = static_cast<char>(6);
	const char status = static_cast<char>(3);

	// send message to relay controller
	this->serialport->port_write(&mode);
	this->serialport->port_write(&message);
	this->serialport->port_write(&status);
}

void RelayController::turnOffAllRelays(){
	const char mode = static_cast<char>(254);
	const char message = static_cast<char>(6);
	const char status = static_cast<char>(0);

	// send message to relay controller
	this->serialport->port_write(&mode);
	this->serialport->port_write(&message);
	this->serialport->port_write(&status);
}

int RelayController::getRelayStatus(int relaynumber){
	int no;
	if(relaynumber == 1) no = 4;
	if(relaynumber == 2) no = 5;
	else return -2; // invalid relaynumber

	const char mode = static_cast<char>(254);
	const char message = static_cast<char>(no);

	// send message to relay controller
	this->serialport->port_write(&mode);
	this->serialport->port_write(&message);

	char status;
	int res = this->serialport->port_read(&status, true);
	if(res) return status;
	else return -1; // no value in readbuffer
}

string RelayController::toString(){
	string s = "[ RelayController, \n Serialport: ";
	s += this->serialport->toString();
	s += "]";
	return s;
}
